/*******************************************************************************
 									CoAN-006 application
						Implementation of matrix keyboard 16 keys
                  				 _ _ _ _ _ _ _ _
                          		|_1_|_2_|_3_|_A_|
                              |_4_|_5_|_6_|_B_|
                              |_7_|_8_|_9_|_C_|
                              |_#_|_0_|_*_|_D_|
                                  |||||||||
 *******************************************************************************/
#if !__SEPARATE_INST_DATA__
#memmap xmem
#endif

#class auto
#use RCM43xx.LIB
#use keyboard.lib

//Buzzer defines
#define BUZZER 3
#define BUZZERINIT	BitWrPortI ( PEDDR,&PEDDRShadow,1,BUZZER )  //PE3 = output
#define BUZZERON   	BitWrPortI ( PEDR, &PEDRShadow, 1,BUZZER )
#define BUZZEROFF  	BitWrPortI ( PEDR, &PEDRShadow, 0,BUZZER )
//Test function to receive and show the pressed key
void showLastKey( char key ){
	printf("%c", key);
}

main()
{
   unsigned char cKey;
   int result;

   //Keyboard initialization;
	keyb_init();
   //Buzzer start-up
   BUZZERINIT;
   BUZZEROFF;

	while(1)
   {  /*****************************
        * Keyboard control task
       *****************************/
      costate
		{  // Look for key pressed
			if (  !( cKey = keyb_get_key() ) )
         	abort;
         //Send last key pressed(o NULL if no one there)
         //to handler function
         showLastKey( keyb_get_asckey( cKey ) );
         BUZZERON;
         waitfor(DelayMs(200));//prevent bounces
         BUZZEROFF;
      }
	}
}


